#include "facade.h"

Facade::Facade()
{
	mSoldiers.push_back(new Soldier(0, "normal"));
	mSoldiers.push_back(new Soldier(1, "general"));
	mSoldiers.push_back(new Soldier(2, "normal"));
	mSoldiers.push_back(new Soldier(3, "captain"));

	mMoveActions.push_back(new MoveAction("forward"));
	mMoveActions.push_back(new MoveAction("backwards"));
	mMoveActions.push_back(new MoveAction("right"));
	mMoveActions.push_back(new MoveAction("left"));
}

Facade::~Facade()
{
	for(int i = 0; i < mSoldiers.size(); ++i)
	{
		delete mSoldiers[i];
	}
	for(int i = 0; i < mMoveActions.size(); ++i)
	{
		delete mMoveActions[i];
	}
}

void Facade::move(int direction)
{
	Action *action = mMoveActions[direction];
	cout << "  " << action->execute() << endl;
}

void Facade::kill(int soldier)
{
	if(mSoldiers.size() == 0)
	{
		return;
	}
	string type = "";
	for(int i = 0; i < mSoldiers.size(); ++i)
	{
		if(soldier == mSoldiers[i]->id())
		{
			type = mSoldiers[i]->type();
			break;
		}
	}
	KillAction action;
	action.setSoldier(type);
	cout << "  " << action.execute() << endl;
}
